C  @(#)pebspage.h	1.3   2/24/97
C
C  This module contains declarations for PEBES-related variables.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  Definition of variables ('*' before variable name denotes dimensioned
C  variable array):
C
C *BNFTPB = benefit actually payable in PEBES calculation.
C *IAGPL1 = planned early retirement age (years and months), after
C             adjusting for current age.
C  IAGPL2 = planned retirement age (adjusted to 62 if none entered), or
C             current age, if greater.
C  MAXPBS = maximum number of PEBES calculations in one run.
C *MFBPBS = MFB in PEBES calculation.
C  PDISRE = number of quarters of coverage required for disability
C             insured status.
C *PIAPBS = PIA in PEBES calculation.
C  PQCDIY = number of years over which quarters of coverage must be
C             earned for disability insured status.
C *PQCREQ = number of quarters of coverage required for fully insured
C           status.
C           I=1 is delayed retirement, 2 is normal retirement, 3 is
C             early retirement, 4 is survivor, 5 is disability.
C
C  Dimension common variables
      INTEGER MAXPBS
      PARAMETER (MAXPBS=5)
      INTEGER PQCREQ(5), PDISRE, PQCDIY, IAGPL1(2), BNFTPB(MAXPBS),
     &IAGPL2
      DOUBLE PRECISION MFBPBS(MAXPBS), PIAPBS(MAXPBS)
      COMMON / CPEBES / MFBPBS,PIAPBS,BNFTPB,PDISRE,PQCDIY,PQCREQ,
     &IAGPL1,IAGPL2
